from __future__ import print_function


class Parser(object):

    def parse(self, obj):
        if isinstance(obj, list):
            self._parse_list(obj)
        elif isinstance(obj, dict):
            self._parse_dict(obj)
        else:
            self.parse_obj(obj)

    def _parse_list(self, obj):
        self.start_list()
        for el in obj:
            self.start_list_el()
            self.parse(el)
            self.end_list_el()
        self.end_list()

    def _parse_dict(self, obj):
        self.start_dict()
        for k, v in obj.iteritems():
            self.start_dict_key()
            self.parse(k)
            self.end_dict_key()
            self.start_dict_val()
            self.parse(v)
            self.end_dict_val()
        self.end_dict()

    parse_obj = lambda self, obj: None
    start_dict_key = end_dict_key = start_list = end_list = \
            start_list_el = end_list_el = start_dict_val = end_dict_val = \
            lambda self: None


class Handler(object):

    def __init__(self):
        self._list_first = True
        self._dict_first = True

    def start_dict_val(self):
        if self._dict_first:
            self._dict_first = False
        else:
            print(", ", end="")

    def start_list_el(self):
        if self._list_first:
            self._list_first = False
        else:
            print(", ", end="")

    def end_dict_key(self):
        print(": ", end="")

    def start_list(self):
        print("[", end="")

    def end_list(self):
        self._list_first = True
        print("]", end="")

    def start_dict(self):
        print("{", end="")

    def end_dict(self):
        self._dict_first = True
        print("}", end="")

    def parse_obj(self, obj):
        print(repr(obj), end="")


if __name__ == "__main__":
    parser = Parser()
    handler = Handler()
    parser.start_list = handler.start_list
    parser.end_list = handler.end_list
    parser.start_dict = handler.start_dict
    parser.end_dict = handler.end_dict
    parser.parse_obj = handler.parse_obj
    parser.start_dict_val = handler.start_dict_val
    parser.end_dict_key = handler.end_dict_key
    parser.start_list_el = handler.start_list_el
    parser.parse([{"hello": "world"}])
